/* @gen.c - general functions
 */
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include "gen.h"
#include "lock.h"

int dolock(FD fd, int type, Seek size)
	{
	int rtn;
	struct flock slock;

	switch (type & L_TYPEMASK)
		{
	case L_TEST:
		rtn = fcntl(fd, F_GETLK, &slock);
		if (slock.l_type == F_UNLCK)
			rtn = slock.l_pid;
		else
			rtn = -1;
		break;
	default:
		switch (type & L_TYPEMASK)
			{
		case L_SHLOCK:
			slock.l_type = F_RDLCK;
			break;
		case L_EXLOCK:
			slock.l_type = F_WRLCK;
			break;
		case L_UNLOCK:
			slock.l_type = F_UNLCK;
			break;
			}
		slock.l_whence = SEEK_CUR;
		slock.l_start = lseek(fd, 0L, SEEK_CUR);
		slock.l_len = size;
		rtn = fcntl(fd, (type & L_WAIT) ? F_SETLKW : F_SETLK, &slock);
		break;
		}
#	ifdef DEB
	errfmt("dolock rtn %d errno %d pid %d me %d\n", rtn, errno, slock.l_pid, getuid());
#	endif
	return rtn;
	}
